diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
index f01219ef5..8e9cd0013 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/mojang/StaticBlockModelMojang.java
@@ -62,11 +62,11 @@ public class StaticBlockModelMojang implements StaticBlockModel {
 
     @Override
     public boolean renderStandalone(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull Tessellator tessellator, double x, double y, double z, int metadata, @NotNull BlockColor color, float brightness, float alpha) {
-        if (compiled.elements.length == 0) return false;
+        if (this.compiled.elements.length == 0) return false;
 
         GL11.glPushMatrix();
-        for (int i = 0; i < compiled.elements.length; i++) {
-            C_Element element = compiled.elements[i];
+        for (int i = 0; i < this.compiled.elements.length; i++) {
+            C_Element element = this.compiled.elements[i];
 
             if (element.shade) {
                 GL11.glEnable(GL11.GL_LIGHTING);
@@ -76,7 +76,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
 
             tessellator.startDrawingQuads();
             for (int face = 0; face < element.faces; face++) {
-                IconCoordinate coordinate = compiled.textures.getOrDefault(element.textures[face], BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED);
+                IconCoordinate coordinate = this.compiled.textures.getOrDefault(element.textures[face], BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED);
 
                 // Todo fix this needing to be hardcoded to get overbright looking right
                 if (LightmapHelper.isLightmapEnabled() && element.lightEmission == 15) {
@@ -116,16 +116,16 @@ public class StaticBlockModelMojang implements StaticBlockModel {
 
     @Override
     public boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
-        if (compiled.elements.length == 0) return false;
+        if (this.compiled.elements.length == 0) return false;
         boolean didRender = false;
         LIGHTING_CACHE.setupCache(sourceModel.block, worldSource, x, y, z);
 
         BlockColor color = BlockColorDispatcher.getInstance().getDispatch(sourceModel.block);
-        for (int i = 0; i < compiled.elements.length; i++) {
-            final C_Element element = compiled.elements[i];
+        for (int i = 0; i < this.compiled.elements.length; i++) {
+            final C_Element element = this.compiled.elements[i];
             for (int face = 0; face < element.faces; face++) {
                 if (cullFaces && cullSide(worldSource, x, y, z, element.cullfaces[face])) continue;
-                final IconCoordinate coordinate = overrideTexture == null ? compiled.textures.getOrDefault(element.textures[face], BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED) : overrideTexture;
+                final IconCoordinate coordinate = overrideTexture == null ? this.compiled.textures.getOrDefault(element.textures[face], BlockModelStandard.BLOCK_TEXTURE_UNASSIGNED) : overrideTexture;
                 final Direction direction = element.directions[face];
 
                 final float minBrightness = element.lightEmission/15f;
@@ -175,7 +175,7 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                         break;
                 }
 
-                final boolean useAO = compiled.data.ambientOcclusion && MC.isAmbientOcclusionEnabled() && element.shade;
+                final boolean useAO = this.compiled.data.ambientOcclusion && MC.isAmbientOcclusionEnabled() && element.shade;
                 final boolean isFullCube = depth <= FULL_CUBE_THRESHOLD && element.shade;
 
                 final float r;
@@ -364,11 +364,11 @@ public class StaticBlockModelMojang implements StaticBlockModel {
                 tessellator.setColorOpaque_F(colorRedTopLeft, colorGreenTopLeft, colorBlueTopLeft);
                 if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordTopLeft);
                 tessellator.addVertexWithUV(
-                    element.vertexData[offset + VERTEX_TOP_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_X] + x + xOff,
-                    element.vertexData[offset + VERTEX_TOP_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_Y] + y + yOff,
-                    element.vertexData[offset + VERTEX_TOP_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_Z] + z + zOff,
-                    coordinate.getSubIconU(element.vertexData[offset + VERTEX_TOP_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_U]),
-                    coordinate.getSubIconV(element.vertexData[offset + VERTEX_TOP_LEFT * FLOATS_PER_VERTEX + VERTEX_FLOAT_V]));
+                    element.vertexData[offset + VERTEX_FLOAT_X] + x + xOff,
+                    element.vertexData[offset + VERTEX_FLOAT_Y] + y + yOff,
+                    element.vertexData[offset + VERTEX_FLOAT_Z] + z + zOff,
+                    coordinate.getSubIconU(element.vertexData[offset + VERTEX_FLOAT_U]),
+                    coordinate.getSubIconV(element.vertexData[offset + VERTEX_FLOAT_V]));
 
                 tessellator.setColorOpaque_F(colorRedBottomLeft, colorGreenBottomLeft, colorBlueBottomLeft);
                 if(LightmapHelper.isLightmapEnabled()) tessellator.setLightmapCoord(lightmapCoordBottomLeft);
@@ -406,27 +406,27 @@ public class StaticBlockModelMojang implements StaticBlockModel {
     @Override
     public @Nullable IconCoordinate getOverlay() {
         // This breaks the modern mc format of using the "#particle" symbol for the overlay, but due to our changes to the spec this is the best way of going about it
-        return compiled.textures.get("#overlay");
+        return this.compiled.textures.get("#overlay");
     }
 
     @Override
     public @Nullable IconCoordinate getParticle(@NotNull Side side) {
-        return compiled.textures.get("#particle_" + side.getDirection().name().toLowerCase(Locale.ROOT));
+        return this.compiled.textures.get("#particle_" + side.getDirection().name().toLowerCase(Locale.ROOT));
     }
 
     @Override
     public int particleColorIndex(@NotNull Side side) {
-        return compiled.particleIndices[side.getId()];
+        return this.compiled.particleIndices[side.getId()];
     }
 
     @Override
     public int renderLayer() {
-        return compiled.renderLayer;
+        return this.compiled.renderLayer;
     }
 
     @Override
     public @NotNull DisplayPos getItemDisplayPos(@NotNull String id) {
-        return compiled.displayPosMap.getOrDefault(id, DisplayPos.DEFAULT_DISPLAY_POS);
+        return this.compiled.displayPosMap.getOrDefault(id, DisplayPos.DEFAULT_DISPLAY_POS);
     }
 
     protected boolean cullSide(WorldSource worldSource, int x, int y, int z, @Nullable Direction direction) {
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/StaticEntityModel.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/StaticEntityModel.java
index 737efb9db..4587b933d 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/StaticEntityModel.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/StaticEntityModel.java
@@ -1,13 +1,13 @@
 package org.useless.dragonfly.models.entity;
 
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBdc;
 
 public interface StaticEntityModel {
     void resetBones();
     @NotNull BoneTransform getTransform(@NotNull String boneId);
-    @NotNull AABB visibleBounds();
+    @NotNull AABBdc visibleBounds();
     void translateToBone(@NotNull String boneId);
     void render(@NotNull Tessellator tessellator);
 }
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
index b19d17b24..b0e4368c8 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/entity/mojang/StaticEntityModelMojang.java
@@ -3,8 +3,9 @@ package org.useless.dragonfly.models.entity.mojang;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.data.entity.mojang.Bone;
 import org.useless.dragonfly.data.entity.mojang.Cube;
@@ -23,7 +24,8 @@ public class StaticEntityModelMojang implements StaticEntityModel {
     public final @NotNull Bone @NotNull [] bones;
     public final EntityGeometryMojangData data;
     public final double inflation;
-    protected final AABB visBounds;
+    protected final @NotNull AABBd visBounds;
+
     public StaticEntityModelMojang(final @NotNull EntityGeometryMojangData data, final double inflation) {
         this.data = data;
         this.transforms = new BoneTransform[this.data.bones.size()];
@@ -39,14 +41,14 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             i++;
         }
 
-        this.visBounds = AABB.fromPool(
-            (this.data.vBoundsOffset[0] - this.data.vBoundsWidth /2),
-            (this.data.vBoundsOffset[1] - this.data.vBoundsHeight/2),
-            (this.data.vBoundsOffset[2] - this.data.vBoundsWidth /2),
-            (this.data.vBoundsOffset[0] + this.data.vBoundsWidth /2),
-            (this.data.vBoundsOffset[1] + this.data.vBoundsHeight/2),
-            (this.data.vBoundsOffset[2] + this.data.vBoundsWidth /2)
-        ).copyUnpooled();
+        this.visBounds = new AABBd(
+            (this.data.vBoundsOffset[0] - this.data.vBoundsWidth / 2),
+            (this.data.vBoundsOffset[1] - this.data.vBoundsHeight / 2),
+            (this.data.vBoundsOffset[2] - this.data.vBoundsWidth / 2),
+            (this.data.vBoundsOffset[0] + this.data.vBoundsWidth / 2),
+            (this.data.vBoundsOffset[1] + this.data.vBoundsHeight / 2),
+            (this.data.vBoundsOffset[2] + this.data.vBoundsWidth / 2)
+        );
     }
 
     @Override
@@ -62,7 +64,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
     }
 
     @Override
-    public @NotNull AABB visibleBounds() {
+    public @NotNull AABBdc visibleBounds() {
         return this.visBounds;
     }
 
@@ -105,6 +107,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
     }
 
     private final double[] uvsBuffer = new double[8];
+
     protected void renderBone(@NotNull final Tessellator tessellator, @NotNull final Bone bone) {
         tessellator.startDrawingQuads();
         for (final Cube cube : bone.cubes) {
@@ -115,7 +118,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
             final double maxX = minX + cube.size[0] + (cube.inflate + bone.inflate + this.inflation) * 2;
             final double maxY = minY + cube.size[1] + (cube.inflate + bone.inflate + this.inflation) * 2;
             final double maxZ = minZ + cube.size[2] + (cube.inflate + bone.inflate + this.inflation) * 2;
-            
+
             if (cube.rotation == null) {
                 // Top
                 Face face = cube.faces[Direction.UP.getId()];
@@ -123,7 +126,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMin;
                     this.uvsBuffer[2] = uMin;
@@ -148,7 +151,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMin;
                     this.uvsBuffer[2] = uMax;
@@ -173,7 +176,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMin;
                     this.uvsBuffer[2] = uMax;
@@ -198,7 +201,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMax;
                     this.uvsBuffer[2] = uMax;
@@ -223,7 +226,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMax;
                     this.uvsBuffer[2] = uMax;
@@ -248,7 +251,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMin;
                     this.uvsBuffer[2] = uMax;
@@ -266,15 +269,14 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     tessellator.addVertexWithUV(minX, maxY, minZ, this.uvsBuffer[(4 + face.uv_rotation * 2) % 8], this.uvsBuffer[(5 + face.uv_rotation * 2) % 8]);
                     tessellator.addVertexWithUV(minX, maxY, maxZ, this.uvsBuffer[(6 + face.uv_rotation * 2) % 8], this.uvsBuffer[(7 + face.uv_rotation * 2) % 8]);
                 }
-            }
-            else {
+            } else {
                 // Top
                 Face face = cube.faces[Direction.UP.getId()];
                 if (face != null) {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMin;
                     this.uvsBuffer[2] = uMin;
@@ -300,7 +302,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMin;
                     this.uvsBuffer[2] = uMax;
@@ -325,7 +327,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMin;
                     this.uvsBuffer[2] = uMax;
@@ -350,7 +352,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMax;
                     this.uvsBuffer[2] = uMax;
@@ -375,7 +377,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMax;
                     this.uvsBuffer[2] = uMax;
@@ -400,7 +402,7 @@ public class StaticEntityModelMojang implements StaticEntityModel {
                     final double uMin = (face.uv[0]) / this.data.textureWidth;
                     final double uMax = (face.uv[0] + face.uv_size[0]) / this.data.textureWidth;
                     final double vMin = (face.uv[1]) / this.data.textureHeight;
-                    final double vMax = (face.uv[1] + face.uv_size[1])  / this.data.textureHeight;
+                    final double vMax = (face.uv[1] + face.uv_size[1]) / this.data.textureHeight;
 
                     this.uvsBuffer[0] = uMin;
                     this.uvsBuffer[2] = uMax;
diff --git a/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java b/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
index 8ff26b7d8..9725c8391 100644
--- a/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
+++ b/game/core/src/main/java/net/minecraft/core/NextTickListEntry.java
@@ -3,92 +3,31 @@ package net.minecraft.core;
 
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.chunk.Chunk;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class NextTickListEntry
     implements Comparable<NextTickListEntry> {
 
-    public static @NotNull CompoundTag serialize(final @NotNull NextTickListEntry entry) {
-        final @NotNull CompoundTag tag = new CompoundTag();
-
-        tag.putInt("pos", compressChunkCoord((short) entry.x, (short) entry.y, (short) entry.z));
-        tag.putShort("blockId", (short) entry.blockId);
-        tag.putLong("creationTime", entry.creationTime);
-        if (entry.delay != 0) {
-            tag.putLong("delay", entry.delay);
-        }
-
-        return tag;
-    }
-
-    public static @Nullable NextTickListEntry deserialize(final @NotNull CompoundTag tag) {
-        if (!tag.containsKey("pos")) {
-            return null;
-        }
-        final int pos = tag.getInteger("pos");
-
-        final short @NotNull [] xyz = new short[3];
-        decompressChunkCoord(pos, xyz);
-
-        if (!tag.containsKey("blockId")) {
-            return null;
-        }
-        final short blockId = tag.getShort("blockId");
-
-        if (!tag.containsKey("creationTime")) {
-            return null;
-        }
-        final long creationTime = tag.getLong("creationTime");
-
-        final @NotNull NextTickListEntry entry = new NextTickListEntry(xyz[0], xyz[1], xyz[2], blockId, creationTime);
-
-        if (tag.containsKey("delay")) {
-            entry.setDelay(tag.getLong("delay"));
-        }
-
-        return entry;
-    }
-
-    public static int compressChunkCoord(final short x, final short y, final short z) {
-        return ((y & 0xFFFF) << 16) | ((z & 0xFF) << 8) | ((x & 0xFF) << 0);
-    }
-
-    public static void decompressChunkCoord(final int compressed, final short @NotNull [] xyz) {
-        final int y = (compressed & 0xFFFF0000) >> 16;
-        final int z = (compressed & 0x0000FF00) >> 8;
-        final int x = (compressed & 0x000000FF) >> 0;
-
-        xyz[0] = (short) x;
-        xyz[1] = (short) y;
-        xyz[2] = (short) z;
-    }
-
     private static long counter = 0L;
 
-    public int x;
-    public int y;
-    public int z;
+    public @NotNull TilePos tilePos;
     public int blockId;
-    public long creationTime;
     public long delay;
-    public boolean loaded;
     private final long entryId;
 
-    public NextTickListEntry(final int x, final int y, final int z, final int blockId, final long creationTime) {
+    public NextTickListEntry(final @NotNull TilePosc tilePos, final int blockId) {
         this.entryId = counter++;
-        this.x = x;
-        this.y = y;
-        this.z = z;
+        this.tilePos = new TilePos(tilePos);
         this.blockId = blockId;
-        this.creationTime = creationTime;
     }
 
     @Override
     public boolean equals(final @Nullable Object obj) {
-        if (obj instanceof NextTickListEntry) {
-            final @NotNull NextTickListEntry entry = (NextTickListEntry) obj;
-            return this.x == entry.x && this.y == entry.y && this.z == entry.z && this.blockId == entry.blockId;
+        if (obj instanceof final @NotNull NextTickListEntry entry) {
+            return this.tilePos.equals(entry.tilePos) && this.blockId == entry.blockId;
         } else {
             return false;
         }
@@ -96,7 +35,7 @@ public class NextTickListEntry
 
     @Override
     public int hashCode() {
-        return (this.x * 128 * 1024 + this.z * 128 + this.y) * 256 + this.blockId;
+        return (this.tilePos.x() * 128 * 1024 + this.tilePos.z() * 128 + this.tilePos.y()) * 256 + this.blockId;
     }
 
     public @NotNull NextTickListEntry setDelay(final long delay) {
@@ -104,16 +43,12 @@ public class NextTickListEntry
         return this;
     }
 
-    public long getEndTime() {
-        return this.creationTime + this.delay;
-    }
-
     @Override
     public int compareTo(final @NotNull NextTickListEntry other) {
-        if (this.getEndTime() < other.getEndTime()) {
+        if (this.delay < other.delay) {
             return -1;
         }
-        if (this.getEndTime() > other.getEndTime()) {
+        if (this.delay > other.delay) {
             return 1;
         }
         if (this.entryId < other.entryId) {
@@ -121,11 +56,4 @@ public class NextTickListEntry
         }
         return this.entryId <= other.entryId ? 0 : 1;
     }
-
-    public @NotNull NextTickListEntry clone() {
-        final @NotNull NextTickListEntry cloned = new NextTickListEntry(this.x, this.y, this.z, this.blockId, this.creationTime);
-        cloned.delay = this.delay;
-
-        return cloned;
-    }
 }
